/****************************************************************/
/* rmdfs - ROSE multi decoded file splitter                     */
/****************************************************************/
/* Splits an ASCII uudecoded text file into single uudecoded    */
/* files.                                                       */
/* Written, because I was to lazy to cut a 500 KB UU-decoded    */
/* file into five parts... NO ERROR CHECKING AT ALL!            */
/****************************************************************/

/*

$Id: rmdfs.lex 1.6 2001/04/20 21:15:20 rose_swe.p200 Exp $
$Header: C:/QC/BIN/LEX/RCS/rmdfs.lex 1.6 2001/04/20 21:15:20 rose_swe.p200 Exp $
$Log: rmdfs.lex $
Revision 1.6  2001/04/20 21:15:20  rose_swe.p200
Works under GNU flex now, compiles now under GCC MinGW 2.95

Revision 1.5  99/11/26  18:07:35  rose_swe
with rcs key words


*/

/****************************************************************/
/*   1994   - initial creation                                  */
/* 20.06.95 - now this sucker can also handle mail, mine and    */
/*            uuencode files.                                   */
/* 10.01.98 - Hexfiles added (asm/debug/doc etc. scripts)       */
/*                                                              */
/*                                                              */
/*            I'm usually download all my INet-Mail from my     */
/*            mail folder (one file) then running RMDFS, et     */
/*            voil: all mail and uu-files are separted.        */
/****************************************************************/

%{
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static char sccsid[] = "%Z% %M% %I% $Id: rmdfs.lex 1.6 2001/04/20 21:15:20 rose_swe.p200 Exp $ ";

#define TRUE    (1==1)
#define FALSE   !TRUE
#define yywrap() 1

int     bFileOpen = FALSE;  /* lock */
FILE    *hFile;
int     nCount = 0;
char    szExt[5], *cP;

void    MyFileOpen(int, char*);        /* proto */
void    MyFileClose(int);

%}

%%
^begin[.]*      {       /* uuencoded/mime */
                        MyFileOpen(nCount++, "uue");
                        fprintf(hFile, "\n%s", yytext);
                }


^[ ]..[ ].*[ ]+STARTS[ ]HERE[ ][.]*    {        /* Hexfiles, asm or deb */

                        cP = strstr(yytext, ".");
                        cP++;
                        strncpy(szExt, cP, 4);
                        szExt[3] = 0;

                        MyFileOpen(nCount++, szExt);
                        /* printf("%s\n", yytext); */
                        fprintf(hFile, "\n; [RMDFS] %s", yytext);
                }

^.*ENDS[ ]HERE[ ][.]*        MyFileClose(FALSE);         /* hexfiles */

^end[.]*        MyFileClose(TRUE);

\1\1\1\1        {       /* pine/mail */
                        if (bFileOpen == TRUE)
                                MyFileClose(FALSE);
                        else
                                MyFileOpen(nCount++, "txt");
                }

\n              if (bFileOpen == TRUE) fprintf(hFile, "\n");

.               if (bFileOpen == TRUE) fprintf(hFile, "%c", yytext[0]);
%%

void MyFileOpen (int nInd, char* szKind)
/* ------------------------------------------------------- */
{
        char szFName[128];

        if (bFileOpen == TRUE)
        {
                fprintf(stderr,"ERROR: File is already open, waiting for end mark!\n");
                return;
        }

        sprintf(szFName, "rmdfs%03x.%s", nInd, szKind);
        fprintf(stderr, "Generating now temp file: %s...\n", szFName);
        hFile = fopen(szFName, "w");
        bFileOpen = TRUE;

}

void MyFileClose(int bLast)
/* ------------------------------------------------------- */
{
        if (bFileOpen == TRUE)
        {
                if (bLast==TRUE)                /* write last line? */
                        fprintf(hFile, "\n%s", yytext);
                fclose(hFile);
        }
        bFileOpen = FALSE;
}

/* -------------------------------------------------------

(C)opyright 1987-2001 (ALL RIGHTS RESERVED!)

            Ŀ
             ROSE Softwareentwicklung       
             Dipl.-Ing. (FH) Ralph Roth     
                                            
             Vollstndige Adresse, inkl.    
             Email, FAX, Telefon & PGP key  
             siehe Datei:   ROSEBBS.TXT     
                                            
            
              

   ------------------------------------------------------- */
